Index: palm/trunk/SOURCE/advec_ws.f90
===================================================================
--- palm/trunk/SOURCE/advec_ws.f90	(revision 4465)
+++ palm/trunk/SOURCE/advec_ws.f90	(revision 4466)
@@ -617,6 +622,6 @@
                          ( ( bc_dirichlet_n .OR. bc_radiation_n )              &
                            .AND. j == nyn   ) )                                &
-                THEN                                                           
-                   advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 12 )      
+                THEN
+                   advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 12 )
                 ELSEIF ( ( .NOT. BTEST(wall_flags_total_0(k,j+2,i),2)  .AND.   &
                                  BTEST(wall_flags_total_0(k,j+1,i),2)  .OR.    &
@@ -627,13 +632,13 @@
                          ( (  bc_dirichlet_n .OR. bc_radiation_n )             &
                            .AND. j == nyn-1 ) )                                &
-                THEN                                                           
-                   advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 13 )      
-!                                                                              
-!--                Clear flag for WS1                                          
-                   advc_flags_m(k,j,i) = IBCLR( advc_flags_m(k,j,i), 12 )      
+                THEN
+                   advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 13 )
+!
+!--                Clear flag for WS1
+                   advc_flags_m(k,j,i) = IBCLR( advc_flags_m(k,j,i), 12 )
                 ELSEIF ( BTEST(wall_flags_total_0(k,j+1,i),2)  .AND.           &
                          BTEST(wall_flags_total_0(k,j+2,i),2)  .AND.           &
-                         BTEST(wall_flags_total_0(k,j-1,i),2) )                & 
-                THEN                                                          
+                         BTEST(wall_flags_total_0(k,j-1,i),2) )                &
+                THEN
                    advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 14 )
 !
@@ -641,53 +646,53 @@
                    advc_flags_m(k,j,i) = IBCLR( advc_flags_m(k,j,i), 12 )
                 ENDIF
-!                                                              
-!--             v component - z-direction. Fluxes are calculated on w-grid                                      
-!--             level. Boundary v-values at/within walls aren't used. 
+!
+!--             v component - z-direction. Fluxes are calculated on w-grid
+!--             level. Boundary v-values at/within walls aren't used.
 !--             WS1 (15), WS3 (16), WS5 (17)
                 IF ( k == nzb+1 )  THEN
                    k_mm = nzb
-                ELSE 
+                ELSE
                    k_mm = k - 2
                 ENDIF
                 IF ( k > nzt-1 )  THEN
                    k_pp = nzt+1
-                ELSE 
+                ELSE
                    k_pp = k + 2
                 ENDIF
                 IF ( k > nzt-2 )  THEN
                    k_ppp = nzt+1
-                ELSE 
+                ELSE
                    k_ppp = k + 3
-                ENDIF  
-                
+                ENDIF
+
                 flag_set = .FALSE.
-                IF ( ( .NOT. BTEST(wall_flags_total_0(k-1,j,i),2)          .AND.   &
-                             BTEST(wall_flags_total_0(k,j,i),2)            .AND.   &
-                             BTEST(wall_flags_total_0(k+1,j,i),2) )        .OR.    &
-                     ( .NOT. BTEST(wall_flags_total_0(k_pp,j,i),2)         .AND.   &                              
-                             BTEST(wall_flags_total_0(k+1,j,i),2)          .AND.   &
-                             BTEST(wall_flags_total_0(k,j,i),2) )          .OR.    &
-                     ( k == nzt .AND. symmetry_flag == 0 ) )                       &
-                THEN                                                           
-                   advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 15 )      
-                   flag_set = .TRUE.                                           
-                ELSEIF ( ( .NOT. BTEST(wall_flags_total_0(k_mm,j,i),2)    .OR.     &
-                           .NOT. BTEST(wall_flags_total_0(k_ppp,j,i),2) ) .AND.    & 
-                                 BTEST(wall_flags_total_0(k-1,j,i),2)     .AND.    &
-                                 BTEST(wall_flags_total_0(k,j,i),2)       .AND.    &
-                                 BTEST(wall_flags_total_0(k+1,j,i),2)     .AND.    &
-                                 BTEST(wall_flags_total_0(k_pp,j,i),2)    .AND.    &
-                           .NOT. flag_set                                  .OR.    & 
-                         ( k == nzt - 1 .AND. symmetry_flag == 0 ) )               &
-                THEN                                                           
-                   advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 16 )      
-                   flag_set = .TRUE.                                           
-                ELSEIF ( BTEST(wall_flags_total_0(k_mm,j,i),2)             .AND.   &
-                         BTEST(wall_flags_total_0(k-1,j,i),2)              .AND.   &
-                         BTEST(wall_flags_total_0(k,j,i),2)                .AND.   &
-                         BTEST(wall_flags_total_0(k+1,j,i),2)              .AND.   &
-                         BTEST(wall_flags_total_0(k_pp,j,i),2)             .AND.   &
-                         BTEST(wall_flags_total_0(k_ppp,j,i),2)            .AND.   &
-                         .NOT. flag_set )                                          &
+                IF ( ( .NOT. BTEST(wall_flags_total_0(k-1,j,i),2)         .AND.&
+                             BTEST(wall_flags_total_0(k,j,i),2)           .AND.&
+                             BTEST(wall_flags_total_0(k+1,j,i),2) )       .OR. &
+                     ( .NOT. BTEST(wall_flags_total_0(k_pp,j,i),2)        .AND.&
+                             BTEST(wall_flags_total_0(k+1,j,i),2)         .AND.&
+                             BTEST(wall_flags_total_0(k,j,i),2) )         .OR. &
+                     ( k == nzt .AND. symmetry_flag == 0 ) )                   &
+                THEN
+                   advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 15 )
+                   flag_set = .TRUE.
+                ELSEIF ( ( .NOT. BTEST(wall_flags_total_0(k_mm,j,i),2)    .OR. &
+                           .NOT. BTEST(wall_flags_total_0(k_ppp,j,i),2) ) .AND.&
+                                 BTEST(wall_flags_total_0(k-1,j,i),2)     .AND.&
+                                 BTEST(wall_flags_total_0(k,j,i),2)       .AND.&
+                                 BTEST(wall_flags_total_0(k+1,j,i),2)     .AND.&
+                                 BTEST(wall_flags_total_0(k_pp,j,i),2)    .AND.&
+                           .NOT. flag_set                                  .OR.&
+                         ( k == nzt - 1 .AND. symmetry_flag == 0 ) )           &
+                THEN
+                   advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 16 )
+                   flag_set = .TRUE.
+                ELSEIF ( BTEST(wall_flags_total_0(k_mm,j,i),2)            .AND.&
+                         BTEST(wall_flags_total_0(k-1,j,i),2)             .AND.&
+                         BTEST(wall_flags_total_0(k,j,i),2)               .AND.&
+                         BTEST(wall_flags_total_0(k+1,j,i),2)             .AND.&
+                         BTEST(wall_flags_total_0(k_pp,j,i),2)            .AND.&
+                         BTEST(wall_flags_total_0(k_ppp,j,i),2)           .AND.&
+                         .NOT. flag_set )                                      &
                 THEN
                    advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 17 )
@@ -703,6 +708,6 @@
              DO  k = nzb+1, nzt
 !
-!--             At first, set flags to WS1. 
-!--             Since fluxes are swapped in advec_ws.f90, this is necessary to 
+!--             At first, set flags to WS1.
+!--             Since fluxes are swapped in advec_ws.f90, this is necessary to
 !--             in order to handle the left/south flux.
                 advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 18 )
@@ -716,6 +721,6 @@
                          ( (  bc_dirichlet_r .OR. bc_radiation_r )             &
                            .AND. i == nxr   ) )                                &
-                THEN                                                           
-                   advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 18 )     
+                THEN
+                   advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 18 )
                 ELSEIF ( ( .NOT. BTEST(wall_flags_total_0(k,j,i+2),3)  .AND.   &
                                  BTEST(wall_flags_total_0(k,j,i+1),3)  .OR.    &
@@ -726,21 +731,21 @@
                          ( ( bc_dirichlet_l .OR.  bc_radiation_l )             &
                            .AND. i == nxlu  ) )                                &
-                THEN                                                           
-                   advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 19 )      
-!                                                                              
-!--                Clear flag for WS1                                          
-                   advc_flags_m(k,j,i) = IBCLR( advc_flags_m(k,j,i), 18 )      
+                THEN
+                   advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 19 )
+!
+!--                Clear flag for WS1
+                   advc_flags_m(k,j,i) = IBCLR( advc_flags_m(k,j,i), 18 )
                 ELSEIF ( BTEST(wall_flags_total_0(k,j,i+1),3)  .AND.           &
                          BTEST(wall_flags_total_0(k,j,i+2),3)  .AND.           &
                          BTEST(wall_flags_total_0(k,j,i-1),3) )                &
-                THEN                                                           
-                   advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i),20 )       
-!                                                                              
-!--                Clear flag for WS1                                          
-                   advc_flags_m(k,j,i) = IBCLR( advc_flags_m(k,j,i), 18 )      
-                ENDIF                                                          
-!                                                                              
-!--             w component - y-direction                                      
-!--             WS1 (21), WS3 (22), WS5 (23)                                   
+                THEN
+                   advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i),20 )
+!
+!--                Clear flag for WS1
+                   advc_flags_m(k,j,i) = IBCLR( advc_flags_m(k,j,i), 18 )
+                ENDIF
+!
+!--             w component - y-direction
+!--             WS1 (21), WS3 (22), WS5 (23)
                 IF ( .NOT. BTEST(wall_flags_total_0(k,j+1,i),3) .OR.           &
                          ( ( bc_dirichlet_s .OR. bc_radiation_s )              &
@@ -748,6 +753,6 @@
                          ( ( bc_dirichlet_n .OR. bc_radiation_n )              &
                            .AND. j == nyn   ) )                                &
-                THEN                                                           
-                   advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 21 )     
+                THEN
+                   advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 21 )
                 ELSEIF ( ( .NOT. BTEST(wall_flags_total_0(k,j+2,i),3)  .AND.   &
                                  BTEST(wall_flags_total_0(k,j+1,i),3)  .OR.    &
@@ -758,13 +763,13 @@
                          ( ( bc_dirichlet_n .OR. bc_radiation_n )              &
                            .AND. j == nyn-1 ) )                                &
-                THEN                                                           
-                   advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 22 )      
-!                                                                              
-!--                Clear flag for WS1                                          
-                   advc_flags_m(k,j,i) = IBCLR( advc_flags_m(k,j,i), 21 )       
+                THEN
+                   advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 22 )
+!
+!--                Clear flag for WS1
+                   advc_flags_m(k,j,i) = IBCLR( advc_flags_m(k,j,i), 21 )
                 ELSEIF ( BTEST(wall_flags_total_0(k,j+1,i),3)  .AND.           &
                          BTEST(wall_flags_total_0(k,j+2,i),3)  .AND.           &
                          BTEST(wall_flags_total_0(k,j-1,i),3) )                &
-                THEN                                                           
+                THEN
                    advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 23 )
 !
@@ -772,8 +777,8 @@
                    advc_flags_m(k,j,i) = IBCLR( advc_flags_m(k,j,i), 21 )
                 ENDIF
-!                                                                              
+!
 !--             w component - z-direction. Fluxes are calculated on scalar grid
-!--             level. Boundary w-values at walls are used. Flux at k=i is  
-!--             defined at scalar position k=i+1 with i being an integer. 
+!--             level. Boundary w-values at walls are used. Flux at k=i is
+!--             defined at scalar position k=i+1 with i being an integer.
 !--             WS1 (24), WS3 (25), WS5 (26)
                 IF ( k == nzb+1 )  THEN
@@ -784,23 +789,23 @@
                 IF ( k > nzt-1 )  THEN
                    k_pp = nzt+1
-                ELSE 
+                ELSE
                    k_pp = k + 2
                 ENDIF
                 IF ( k > nzt-2 )  THEN
                    k_ppp = nzt+1
-                ELSE 
+                ELSE
                    k_ppp = k + 3
-                ENDIF  
-                
-                flag_set = .FALSE.                                        
-                IF ( ( .NOT. BTEST(wall_flags_total_0(k,j,i),3)          .AND.   &
-                             BTEST(wall_flags_total_0(k+1,j,i),3) )      .OR.    &
-                     ( .NOT. BTEST(wall_flags_total_0(k+1,j,i),3)        .AND.   &
-                             BTEST(wall_flags_total_0(k,j,i),3) )        .OR.    &        
-                     k == nzt -1 )                                               &
+                ENDIF
+
+                flag_set = .FALSE.
+                IF ( ( .NOT. BTEST(wall_flags_total_0(k,j,i),3)          .AND. &
+                             BTEST(wall_flags_total_0(k+1,j,i),3) )      .OR.  &
+                     ( .NOT. BTEST(wall_flags_total_0(k+1,j,i),3)        .AND. &
+                             BTEST(wall_flags_total_0(k,j,i),3) )        .OR.  &
+                     k == nzt -1 )                                             &
                 THEN
 !
 !--                Please note, at k == nzb_w_inner(j,i) a flag is explicitly
-!--                set, although this is not a prognostic level. However, 
+!--                set, although this is not a prognostic level. However,
 !--                contrary to the advection of u,v and s this is necessary
 !--                because flux_t(nzb_w_inner(j,i)) is used for the tendency
@@ -808,23 +813,23 @@
                    advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 24 )
                    flag_set = .TRUE.
-                ELSEIF ( ( .NOT. BTEST(wall_flags_total_0(k-1,j,i),3)    .AND.   &
-                                 BTEST(wall_flags_total_0(k,j,i),3)      .AND.   &
-                                 BTEST(wall_flags_total_0(k+1,j,i),3)    .AND.   &
-                                 BTEST(wall_flags_total_0(k_pp,j,i),3) ) .OR.    &
-                         ( .NOT. BTEST(wall_flags_total_0(k_pp,j,i),3)   .AND.   &
-                                 BTEST(wall_flags_total_0(k+1,j,i),3)    .AND.   &
-                                 BTEST(wall_flags_total_0(k,j,i),3)      .AND.   &
-                                 BTEST(wall_flags_total_0(k-1,j,i),3) )  .AND.   &
-                           .NOT. flag_set                          .OR.          & 
-                         k == nzt - 2 )                                          &
-                THEN                                                           
-                   advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 25 )      
-                   flag_set = .TRUE.                                           
-                ELSEIF ( BTEST(wall_flags_total_0(k-1,j,i),3)            .AND.   &
-                         BTEST(wall_flags_total_0(k,j,i),3)              .AND.   &
-                         BTEST(wall_flags_total_0(k+1,j,i),3)            .AND.   &
-                         BTEST(wall_flags_total_0(k_pp,j,i),3)           .AND.   &
-                         .NOT. flag_set )                                        &
-                THEN                                                                
+                ELSEIF ( ( .NOT. BTEST(wall_flags_total_0(k-1,j,i),3)    .AND. &
+                                 BTEST(wall_flags_total_0(k,j,i),3)      .AND. &
+                                 BTEST(wall_flags_total_0(k+1,j,i),3)    .AND. &
+                                 BTEST(wall_flags_total_0(k_pp,j,i),3) ) .OR.  &
+                         ( .NOT. BTEST(wall_flags_total_0(k_pp,j,i),3)   .AND. &
+                                 BTEST(wall_flags_total_0(k+1,j,i),3)    .AND. &
+                                 BTEST(wall_flags_total_0(k,j,i),3)      .AND. &
+                                 BTEST(wall_flags_total_0(k-1,j,i),3) )  .AND. &
+                           .NOT. flag_set                          .OR.        &
+                         k == nzt - 2 )                                        &
+                THEN
+                   advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 25 )
+                   flag_set = .TRUE.
+                ELSEIF ( BTEST(wall_flags_total_0(k-1,j,i),3)            .AND. &
+                         BTEST(wall_flags_total_0(k,j,i),3)              .AND. &
+                         BTEST(wall_flags_total_0(k+1,j,i),3)            .AND. &
+                         BTEST(wall_flags_total_0(k_pp,j,i),3)           .AND. &
+                         .NOT. flag_set )                                      &
+                THEN
                    advc_flags_m(k,j,i) = IBSET( advc_flags_m(k,j,i), 26 )
                 ENDIF
@@ -837,5 +842,5 @@
        CALL exchange_horiz_int( advc_flags_m, nys, nyn, nxl, nxr, nzt, nbgp )
 !
-!--    Set boundary flags at inflow and outflow boundary in case of 
+!--    Set boundary flags at inflow and outflow boundary in case of
 !--    non-cyclic boundary conditions.
        IF ( bc_dirichlet_l  .OR.  bc_radiation_l )  THEN
@@ -844,5 +849,5 @@
 
        IF ( bc_dirichlet_r  .OR.  bc_radiation_r )  THEN
-         advc_flags_m(:,:,nxr+1) = advc_flags_m(:,:,nxr)
+          advc_flags_m(:,:,nxr+1) = advc_flags_m(:,:,nxr)
        ENDIF
 
@@ -863,5 +868,5 @@
 !> Initialization of flags to control the order of the advection scheme near
 !> solid walls and non-cyclic inflow boundaries, where the order is sucessively
-!> degraded. 
+!> degraded.
 !------------------------------------------------------------------------------!
     SUBROUTINE ws_init_flags_scalar( non_cyclic_l, non_cyclic_n, non_cyclic_r, &
@@ -885,7 +890,7 @@
        LOGICAL ::  non_cyclic_s !< flag that indicates non-cyclic boundary on the south
 
-       LOGICAL, OPTIONAL ::  extensive_degrad !< flag indicating that extensive degradation is required, e.g. for 
+       LOGICAL, OPTIONAL ::  extensive_degrad !< flag indicating that extensive degradation is required, e.g. for
                                               !< passive scalars nearby topography along the horizontal directions,
-                                              !< as no monotonic limiter can be applied there 
+                                              !< as no monotonic limiter can be applied there
 !
 !--    Set flags to steer the degradation of the advection scheme in advec_ws
@@ -900,77 +905,77 @@
 !--             scalar - x-direction
 !--             WS1 (0), WS3 (1), WS5 (2)
-                IF ( ( .NOT. BTEST(wall_flags_total_0(k,j,i+1),0)      .OR.      &
-                       .NOT. BTEST(wall_flags_total_0(k,j,i+2),0)      .OR.      &   
-                       .NOT. BTEST(wall_flags_total_0(k,j,i-1),0) )    .OR.      &
-                       ( non_cyclic_l  .AND.  i == 0  )                .OR.      &
-                       ( non_cyclic_r  .AND.  i == nx ) )  THEN           
-                 advc_flag(k,j,i) = IBSET( advc_flag(k,j,i), 0 )             
-                ELSEIF ( ( .NOT. BTEST(wall_flags_total_0(k,j,i+3),0)  .AND.     &
-                                 BTEST(wall_flags_total_0(k,j,i+1),0)  .AND.     &
-                                 BTEST(wall_flags_total_0(k,j,i+2),0)  .AND.     &
-                                 BTEST(wall_flags_total_0(k,j,i-1),0)            &
-                         )                       .OR.                            &
-                         ( .NOT. BTEST(wall_flags_total_0(k,j,i-2),0)  .AND.     &
-                                 BTEST(wall_flags_total_0(k,j,i+1),0)  .AND.     &
-                                 BTEST(wall_flags_total_0(k,j,i+2),0)  .AND.     &
-                                 BTEST(wall_flags_total_0(k,j,i-1),0)            &
-                         )                                                       &
-                                                 .OR.                            &
-                         ( non_cyclic_r  .AND.  i == nx-1 )  .OR.                &
-                         ( non_cyclic_l  .AND.  i == 1    ) )  THEN           
-                   advc_flag(k,j,i) = IBSET( advc_flag(k,j,i), 1 )             
-                ELSEIF ( BTEST(wall_flags_total_0(k,j,i+1),0)           .AND.    &
-                         BTEST(wall_flags_total_0(k,j,i+2),0)           .AND.    &
-                         BTEST(wall_flags_total_0(k,j,i+3),0)           .AND.    &
-                         BTEST(wall_flags_total_0(k,j,i-1),0)           .AND.    &
-                         BTEST(wall_flags_total_0(k,j,i-2),0) )                  &
-                THEN                                                           
-                   advc_flag(k,j,i) = IBSET( advc_flag(k,j,i), 2 )             
-                ENDIF                                                          
-!                                                                              
-!--             scalar - y-direction                                           
-!--             WS1 (3), WS3 (4), WS5 (5)                                      
-                IF ( ( .NOT. BTEST(wall_flags_total_0(k,j+1,i),0)        .OR.    &
-                       .NOT. BTEST(wall_flags_total_0(k,j+2,i),0)        .OR.    &   
-                       .NOT. BTEST(wall_flags_total_0(k,j-1,i),0))       .OR.    &
-                     ( non_cyclic_s  .AND.  j == 0  )                    .OR.    &
-                     ( non_cyclic_n  .AND.  j == ny ) )  THEN                                                           
-                   advc_flag(k,j,i) = IBSET( advc_flag(k,j,i), 3 )             
-!                                                                              
-!--             WS3                                                            
-                ELSEIF ( ( .NOT. BTEST(wall_flags_total_0(k,j+3,i),0)    .AND.   &
-                                 BTEST(wall_flags_total_0(k,j+1,i),0)    .AND.   &
-                                 BTEST(wall_flags_total_0(k,j+2,i),0)    .AND.   &
-                                 BTEST(wall_flags_total_0(k,j-1,i),0)            &
-                         )                       .OR.                            &
-                         ( .NOT. BTEST(wall_flags_total_0(k,j-2,i),0)    .AND.   &
-                                 BTEST(wall_flags_total_0(k,j+1,i),0)    .AND.   &
-                                 BTEST(wall_flags_total_0(k,j+2,i),0)    .AND.   &
-                                 BTEST(wall_flags_total_0(k,j-1,i),0)            &
-                         )                                                       &
-                                                 .OR.                            &
-                         ( non_cyclic_s  .AND.  j == 1    )  .OR.                &
-                         ( non_cyclic_n  .AND.  j == ny-1 ) )  THEN           
-                   advc_flag(k,j,i) = IBSET( advc_flag(k,j,i), 4 )             
-!                                                                              
-!--             WS5                                                            
-                ELSEIF ( BTEST(wall_flags_total_0(k,j+1,i),0)           .AND.    &
-                         BTEST(wall_flags_total_0(k,j+2,i),0)           .AND.    &
-                         BTEST(wall_flags_total_0(k,j+3,i),0)           .AND.    &
-                         BTEST(wall_flags_total_0(k,j-1,i),0)           .AND.    &
-                         BTEST(wall_flags_total_0(k,j-2,i),0) )                  &
-                THEN                                                           
-                   advc_flag(k,j,i) = IBSET( advc_flag(k,j,i), 5 )             
+                IF ( ( .NOT. BTEST(wall_flags_total_0(k,j,i+1),0)      .OR.    &
+                       .NOT. BTEST(wall_flags_total_0(k,j,i+2),0)      .OR.    &
+                       .NOT. BTEST(wall_flags_total_0(k,j,i-1),0) )    .OR.    &
+                       ( non_cyclic_l  .AND.  i == 0  )                .OR.    &
+                       ( non_cyclic_r  .AND.  i == nx ) )  THEN
+                 advc_flag(k,j,i) = IBSET( advc_flag(k,j,i), 0 )
+                ELSEIF ( ( .NOT. BTEST(wall_flags_total_0(k,j,i+3),0)  .AND.   &
+                                 BTEST(wall_flags_total_0(k,j,i+1),0)  .AND.   &
+                                 BTEST(wall_flags_total_0(k,j,i+2),0)  .AND.   &
+                                 BTEST(wall_flags_total_0(k,j,i-1),0)          &
+                         )                       .OR.                          &
+                         ( .NOT. BTEST(wall_flags_total_0(k,j,i-2),0)  .AND.   &
+                                 BTEST(wall_flags_total_0(k,j,i+1),0)  .AND.   &
+                                 BTEST(wall_flags_total_0(k,j,i+2),0)  .AND.   &
+                                 BTEST(wall_flags_total_0(k,j,i-1),0)          &
+                         )                                                     &
+                                                 .OR.                          &
+                         ( non_cyclic_r  .AND.  i == nx-1 )  .OR.              &
+                         ( non_cyclic_l  .AND.  i == 1    ) )  THEN
+                   advc_flag(k,j,i) = IBSET( advc_flag(k,j,i), 1 )
+                ELSEIF ( BTEST(wall_flags_total_0(k,j,i+1),0)           .AND.  &
+                         BTEST(wall_flags_total_0(k,j,i+2),0)           .AND.  &
+                         BTEST(wall_flags_total_0(k,j,i+3),0)           .AND.  &
+                         BTEST(wall_flags_total_0(k,j,i-1),0)           .AND.  &
+                         BTEST(wall_flags_total_0(k,j,i-2),0) )                &
+                THEN
+                   advc_flag(k,j,i) = IBSET( advc_flag(k,j,i), 2 )
                 ENDIF
 !
-!--             Near topography, set horizontal advection scheme to 1st order 
-!--             for passive scalars, even if only one direction may be 
+!--             scalar - y-direction
+!--             WS1 (3), WS3 (4), WS5 (5)
+                IF ( ( .NOT. BTEST(wall_flags_total_0(k,j+1,i),0)        .OR.  &
+                       .NOT. BTEST(wall_flags_total_0(k,j+2,i),0)        .OR.  &
+                       .NOT. BTEST(wall_flags_total_0(k,j-1,i),0))       .OR.  &
+                     ( non_cyclic_s  .AND.  j == 0  )                    .OR.  &
+                     ( non_cyclic_n  .AND.  j == ny ) )  THEN
+                   advc_flag(k,j,i) = IBSET( advc_flag(k,j,i), 3 )
+!
+!--             WS3
+                ELSEIF ( ( .NOT. BTEST(wall_flags_total_0(k,j+3,i),0)    .AND. &
+                                 BTEST(wall_flags_total_0(k,j+1,i),0)    .AND. &
+                                 BTEST(wall_flags_total_0(k,j+2,i),0)    .AND. &
+                                 BTEST(wall_flags_total_0(k,j-1,i),0)          &
+                         )                       .OR.                          &
+                         ( .NOT. BTEST(wall_flags_total_0(k,j-2,i),0)    .AND. &
+                                 BTEST(wall_flags_total_0(k,j+1,i),0)    .AND. &
+                                 BTEST(wall_flags_total_0(k,j+2,i),0)    .AND. &
+                                 BTEST(wall_flags_total_0(k,j-1,i),0)          &
+                         )                                                     &
+                                                 .OR.                          &
+                         ( non_cyclic_s  .AND.  j == 1    )  .OR.              &
+                         ( non_cyclic_n  .AND.  j == ny-1 ) )  THEN
+                   advc_flag(k,j,i) = IBSET( advc_flag(k,j,i), 4 )
+!
+!--             WS5
+                ELSEIF ( BTEST(wall_flags_total_0(k,j+1,i),0)           .AND.  &
+                         BTEST(wall_flags_total_0(k,j+2,i),0)           .AND.  &
+                         BTEST(wall_flags_total_0(k,j+3,i),0)           .AND.  &
+                         BTEST(wall_flags_total_0(k,j-1,i),0)           .AND.  &
+                         BTEST(wall_flags_total_0(k,j-2,i),0) )                &
+                THEN
+                   advc_flag(k,j,i) = IBSET( advc_flag(k,j,i), 5 )
+                ENDIF
+!
+!--             Near topography, set horizontal advection scheme to 1st order
+!--             for passive scalars, even if only one direction may be
 !--             blocked by topography. These locations will be identified
-!--             by wall_flags_total_0 bit 31. Note, since several modules define 
-!--             advection flags but may apply different scalar boundary 
-!--             conditions, bit 31 is temporarily stored on advc_flags. 
-!--             Moreover, note that this extended degradtion for passive 
-!--             scalars is not required for the vertical direction as there 
-!--             the monotonic limiter can be applied. 
+!--             by wall_flags_total_0 bit 31. Note, since several modules define
+!--             advection flags but may apply different scalar boundary
+!--             conditions, bit 31 is temporarily stored on advc_flags.
+!--             Moreover, note that this extended degradtion for passive
+!--             scalars is not required for the vertical direction as there
+!--             the monotonic limiter can be applied.
                 IF ( PRESENT( extensive_degrad ) )  THEN
                    IF ( extensive_degrad )  THEN
@@ -980,5 +985,5 @@
                       IF( BTEST( advc_flag(k,j,i), 31 ) )  THEN
 !
-!--                      Clear flags that might indicate higher-order 
+!--                      Clear flags that might indicate higher-order
 !--                      advection along x- and y-direction.
                          advc_flag(k,j,i) = IBCLR( advc_flag(k,j,i), 1 )
